#include<stdio.h>

//pomocna funkcija:
//vraca 1 ako je broj prost, inace 0
int prost(int broj){
    if(broj < 2)
        return 0;
    int i;
    for(i = 2; i < broj; ++i)
        if(broj % i == 0)
            return 0;
    return 1;
}


void transformacija(int n, int X[][20]){
    int i, j;
    //1. korak
    for(i = 0; i < n; ++i)
        for(j = 0; j < n; ++j)
            if(prost(X[i][j]) == 1)
                X[i][j] = 0;


    //2. korak
    for(i = 0; i < n; ++i){
        int k = 0;
        for(j = 0; j < n; ++j){
            if(X[i][j] != 0){
                X[i][k] = X[i][j];
                ++k;
            }
        }
        //preostali dio reda popunimo nulama
        for(; k < n; ++k)
            X[i][k] = 0;
    }


    //3. korak
    for(i = 0; i < n; ++i){
        //koliko ima elemenata u retku
        //koji su razliciti od nule
        //(zbog 2. koraka takvi su na pocetku retka!)
        int broj = 0;
        for(j = 0; j < n; ++j)
            if(X[i][j] != 0)
                broj++;
        //sortiranje pocetnog dijela i-tog retka duljine broj
        int k;
        for(j = 0; j < broj - 1; ++j){
            for(k = j + 1; k < broj; ++k){
                if(X[i][j] > X[i][k]){
                    int temp = X[i][j];
                    X[i][j] = X[i][k];
                    X[i][k] = temp;
                }
            }
        }
    }
}


//ovdje je X radi testiranja (ne ocekuje se to u rjesenjima)
int X[20][20] = {
    {5,4,9,7,1},
    {2,7,3,6,2},
    {4,9,2,1,9},
    {7,3,2,5,7},
    {6,5,4,1,2}
};


int main(int argc, char* argv[]){
    //ucitamo n s komandne linije
    int n; //za ovdje navedeni primjer treba biti n = 5
    //n = atoi(argv[1]); <- ne ovako (zato je u ovome zadatku
    // nije dozvoljeno koristiti biblioteku stdlib.h, pa onda ni atoi ;)
    //no, moze npr. ovako (ili moze i ,,rucno'' pretvaranje u broj):
    sscanf(argv[1], "%d", &n);

    //trazeni poziv funkcije
    transformacija(n, X);

    //ispis (promijenjene) matrice
    //(ovdje je samo radi testiranja - ne ocekuje se u rjesenjima)
    int i, j;
    for(i = 0; i < n; ++i){
        for(j = 0; j < n; ++j)
            printf("%4d", X[i][j]);
        printf("\n");
    }

    return 0;
}
