#include<stdio.h>

//pomocna funkcija:
//vraca 1 ako je broj prost, inace 0
int prost(int broj){
    if(broj < 2)
        return 0;
    int i;
    for(i = 2; i < broj; ++i)
        if(broj % i == 0)
            return 0;
    return 1;
}


void transformacija(int m, int Y[][20]){
    int i, j;
    //1. korak
    for(i = 0; i < m; ++i)
        for(j = 0; j < m; ++j)
            if(prost(Y[i][j]) == 1)
                Y[i][j] = 0;


    //2. korak
    for(j = 0; j < m; ++j){
        int k = 0;
        for(i = 0; i < m; ++i){
            if(Y[i][j] != 0){
                Y[k][j] = Y[i][j];
                ++k;
            }
        }
        //preostali dio stupca popunimo nulama
        for(; k < m; ++k)
            Y[k][j] = 0;
    }


    //3. korak
    for(j = 0; j < m; ++j){
        //koliko ima elemenata u stupcu
        //koji su razliciti od nule
        //(zbog 2. koraka takvi su na pocetku stupca!)
        int broj = 0;
        for(i = 0; i < m; ++i)
            if(Y[i][j] != 0)
                broj++;
        //sortiranje pocetnog dijela j-tog stupca duljine broj
        int k;
        for(i = 0; i < broj - 1; ++i){
            for(k = i + 1; k < broj; ++k){
                if(Y[i][j] > Y[k][j]){
                    int temp = Y[i][j];
                    Y[i][j] = Y[k][j];
                    Y[k][j] = temp;
                }
            }
        }
    }
}


//ovdje je Y radi testiranja (ne ocekuje se to u rjesenjima)
int Y[20][20] = {
    {5,4,9,7,1},
    {2,7,3,6,2},
    {4,9,2,1,9},
    {7,3,2,5,7},
    {6,5,4,1,2}
};


int main(int argc, char* argv[]){
    //ucitamo m s komandne linije
    int m; //za ovdje navedeni primjer treba biti m = 5
    //m = atoi(argv[1]); <- ne ovako (zato je u ovome zadatku
    // nije dozvoljeno koristiti biblioteku stdlib.h, pa onda ni atoi ;)
    //no, moze npr. ovako (ili moze i ,,rucno'' pretvaranje u broj):
    sscanf(argv[1], "%d", &m);

    //trazeni poziv funkcije
    transformacija(m, Y);

    //ispis (promijenjene) matrice
    //(ovdje je samo radi testiranja - ne ocekuje se u rjesenjima)
    int i, j;
    for(i = 0; i < m; ++i){
        for(j = 0; j < m; ++j)
            printf("%4d", Y[i][j]);
        printf("\n");
    }

    return 0;
}

